Debian Bug report logs - #195509
Please support Fortran 90 using new gfortran

version graph

Package: mpich; Maintainer for mpich is Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>; Source for mpich is src:mpich.

Reported by: Egon Willighagen <egonw@sci.kun.nl>

Date: Sat, 31 May 2003 05:03:03 UTC

Severity: important

Tags: patch

Fixed in version mpich/1.2.7-6

Done: hazelsct@debian.org (Adam C. Powell, IV)

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, hazelsct@debian.org (Adam C. Powell, IV):
Bug#195509; Package mpich. Full text and rfc822 format available.

Acknowledgement sent to Egon Willighagen <egonw@sci.kun.nl>:
New Bug report received and forwarded. Copy sent to hazelsct@debian.org (Adam C. Powell, IV). Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Egon Willighagen <egonw@sci.kun.nl>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: mpich: mpif90 cannot compile due to problem in script
Date: Sat, 31 May 2003 06:54:26 +0200
Package: mpich
Version: 1.2.5-5
Severity: important


The script /usr/lib/mpich/bin/mpif90 cannot be used to compile fortran code
due to an error in the script (?):

egonw@chemo10:/tmp/ABINIT/Lib_numrecip$ /usr/lib/mpich/bin/mpif90 -c polcoe.f
/usr/lib/mpich/bin/mpif90: line 332: eval: -c: invalid option
eval: usage: eval [arg ...]

The usage is exactly given as such in the help of the script.

-- System Information:
Debian Release: testing/unstable
Architecture: i386
Kernel: Linux chemo10 2.4.20 #1 SMP Tue Apr 8 15:48:19 CEST 2003 i686
Locale: LANG=C, LC_CTYPE=C

Versions of packages mpich depends on:
ii  libc6                         2.3.1-14   GNU C Library: Shared libraries an
ii  libmpich1.0                   1.2.5-5    mpich runtime shared library
ii  mpich-common                  1.2.5-5    Manpages and other common files fo
ii  ssh [rsh-client]              1:3.5p1-4  Secure rlogin/rsh/rcp replacement 

-- no debconf information




Bug reassigned from package `mpich' to `wnpp'. Request was from Adam C Powell IV <hazelsct@debian.org> to control@bugs.debian.org. Full text and rfc822 format available.

Changed Bug title. Request was from Adam C Powell IV <hazelsct@debian.org> to control@bugs.debian.org. Full text and rfc822 format available.

Severity set to `wishlist'. Request was from Göran Weinholt <weinholt@dtek.chalmers.se> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org:
Bug#195509; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to "Artur R. Czechowski" <arturcz@hell.pl>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org. Full text and rfc822 format available.

Message #16 received at 195509@bugs.debian.org (full text, mbox):

From: "Artur R. Czechowski" <arturcz@hell.pl>
To: hazelsct@debian.org
Cc: 195509@bugs.debian.org
Subject: Could you provide more information about g95?
Date: Tue, 9 Sep 2003 00:36:00 +0200
Hello Adam,
Could you provide more information about g95 as required in wnpp packages?

* Package name    : 
  Version         : 
  Upstream Author : 
* URL             : 
* License         : 
  Description     : 

Regards
	Artur
-- 
sklepowa: a 18 latek mamy?
Anetek: a mamy, mamy, nawet 30...



Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org:
Bug#195509; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Adam C Powell IV <hazelsct@debian.org>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org. Full text and rfc822 format available.

Message #21 received at 195509@bugs.debian.org (full text, mbox):

From: Adam C Powell IV <hazelsct@debian.org>
To: "Artur R. Czechowski" <arturcz@hell.pl>
Cc: 195509@bugs.debian.org
Subject: Re: Could you provide more information about g95?
Date: 08 Sep 2003 21:55:27 -0400
On Mon, 2003-09-08 at 18:36, Artur R. Czechowski wrote:
    Hello Adam,
    Could you provide more information about g95 as required in wnpp packages?
    
    * Package name    : 
      Version         : 
      Upstream Author : 
    * URL             : 
    * License         : 
      Description     : 

I'm sorry, I should have CC'd the following to this bug when I sent it
to the submitter at the end of July:

Greetings,

Thought this news might be of interest: g95 will be in gcc 3.5.
http://gcc-g95.sourceforge.net/ (scroll down to News/July 27)

I don't know whether this means the bug can be closed, perhaps it should
wait until the gcc which includes it is released...

Cheers,
-- 
-Adam P.

GPG fingerprint: D54D 1AEE B11C CE9B A02B  C5DD 526F 01E8 564E E4B6

Welcome to the best software in the world today cafe!
http://lyre.mit.edu/~powell/The_Best_Stuff_In_The_World_Today_Cafe.ogg



Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org:
Bug#195509; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to "Artur R. Czechowski" <arturcz@hell.pl>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org. Full text and rfc822 format available.

Message #26 received at 195509@bugs.debian.org (full text, mbox):

From: "Artur R. Czechowski" <arturcz@hell.pl>
To: Adam C Powell IV <hazelsct@debian.org>
Cc: 195509@bugs.debian.org
Subject: Re: Could you provide more information about g95?
Date: Tue, 9 Sep 2003 12:48:38 +0200
retitle 195509 RFP: g95 -- GNU Fortran 95
thanks

On Mon, Sep 08, 2003 at 09:55:27PM -0400, Adam C Powell IV wrote:
> Thought this news might be of interest: g95 will be in gcc 3.5.
> http://gcc-g95.sourceforge.net/ (scroll down to News/July 27)
> I don't know whether this means the bug can be closed, perhaps it should
> wait until the gcc which includes it is released...
I set a proper title (to be compliant with wnpp rules) to this bug.
I also Bcc this mail to Debian gcc maintainers. Maybe the bug should be
reassigned to gcc as a request of new version?

Cheers
	Artur
-- 
<Stomil> Szymon: nie zachowuj sie jak uzytkownik.
<Szymon> Alex: nie zachowuj się jak Bill Gates.
<Spriggana> panowie, chyba obowiązuje tu jakaś kultura! :>



Changed Bug title. Request was from "Artur R. Czechowski" <arturcz@hell.pl> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org:
Bug#195509; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Matthias Klose <doko@cs.tu-berlin.de>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org. Full text and rfc822 format available.

Message #33 received at 195509@bugs.debian.org (full text, mbox):

From: Matthias Klose <doko@cs.tu-berlin.de>
To: "Artur R. Czechowski" <arturcz@hell.pl>
Cc: Adam C Powell IV <hazelsct@debian.org>, 195509@bugs.debian.org
Subject: Re: Could you provide more information about g95?
Date: Tue, 9 Sep 2003 21:45:59 +0200
Artur R. Czechowski writes:
> retitle 195509 RFP: g95 -- GNU Fortran 95
> thanks
> 
> On Mon, Sep 08, 2003 at 09:55:27PM -0400, Adam C Powell IV wrote:
> > Thought this news might be of interest: g95 will be in gcc 3.5.
> > http://gcc-g95.sourceforge.net/ (scroll down to News/July 27)
> > I don't know whether this means the bug can be closed, perhaps it should
> > wait until the gcc which includes it is released...
> I set a proper title (to be compliant with wnpp rules) to this bug.
> I also Bcc this mail to Debian gcc maintainers. Maybe the bug should be
> reassigned to gcc as a request of new version?

g95 is developed in the tree-ssa branch (which probably will become
gcc-3.5, maybe at the end of 2004 or beginning of 2005). Once gcc-3.4
is part of unstable (when it is released, probably spring 2004), g95
will be part of the gcc-snapshot package. Please note tha all dates
given here are speculations.

	Matthias




Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org:
Bug#195509; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to "Artur R. Czechowski" <arturcz@hell.pl>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org. Full text and rfc822 format available.

Message #38 received at 195509@bugs.debian.org (full text, mbox):

From: "Artur R. Czechowski" <arturcz@hell.pl>
To: Matthias Klose <doko@cs.tu-berlin.de>
Cc: Adam C Powell IV <hazelsct@debian.org>, 195509@bugs.debian.org
Subject: Re: Could you provide more information about g95?
Date: Tue, 9 Sep 2003 22:44:11 +0200
On Tue, Sep 09, 2003 at 09:45:59PM +0200, Matthias Klose wrote:
> g95 is developed in the tree-ssa branch (which probably will become
> gcc-3.5, maybe at the end of 2004 or beginning of 2005). Once gcc-3.4
> is part of unstable (when it is released, probably spring 2004), g95
> will be part of the gcc-snapshot package. Please note tha all dates
> given here are speculations.
It does not look good for a bug submitter, but situation is clear:
if anyone can spare some time and have sufficient knowledge to package
g95 he should do it.

Well... I set my atd to send me email at 2004 Apr. I'll ask you again
about this case.

Regards
	Artur
-- 
Tapetka z RAMu, Windows hej!
	/z pamiętnika administratora/



Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>:
Bug#195509; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Konrad Dąbrowski <konraddabrowski@yahoo.co.uk>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>. Full text and rfc822 format available.

Message #43 received at 195509@bugs.debian.org (full text, mbox):

From: Konrad Dąbrowski <konraddabrowski@yahoo.co.uk>
To: 195509@bugs.debian.org
Subject: Solved by gfortran-4.0?
Date: Thu, 16 Jun 2005 16:31:14 +0100
Should this bug can be shut now since gfortran-4.0 is in unstable?
Thanks
Konrad

		
___________________________________________________________ 
How much free photo storage do you get? Store your holiday 
snaps for FREE with Yahoo! Photos http://uk.photos.yahoo.com



Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>:
Bug#195509; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Adam C Powell IV <hazelsct@debian.org>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>. Full text and rfc822 format available.

Message #48 received at 195509@bugs.debian.org (full text, mbox):

From: Adam C Powell IV <hazelsct@debian.org>
To: 195509@bugs.debian.org, konraddabrowski@yahoo.co.uk
Cc: control@bugs.debian.org
Subject: Re: Solved by gfortran-4.0?
Date: Mon, 11 Jul 2005 13:57:10 -0400
reassign 195509 mpich
retitle 195509 Please support Fortran 90 using new gfortran
thanks

Hello Konrad,

Thanks for the note on this bug.  I'm just now following up on my old
bugs in my Debian bugs folder.

The bug was originally about mpich's lack of support for fortran 90.
Now that gfortran-4.0 is in unstable, I'm reassigning it back to mpich
(which I maintain).

Thanks,

-Adam
-- 
GPG fingerprint: D54D 1AEE B11C CE9B A02B  C5DD 526F 01E8 564E E4B6

Welcome to the best software in the world today cafe!
http://www.take6.com/albums/greatesthits.html



Bug reassigned from package `wnpp' to `mpich'. Request was from Adam C Powell IV <hazelsct@debian.org> to control@bugs.debian.org. Full text and rfc822 format available.

Changed Bug title. Request was from Adam C Powell IV <hazelsct@debian.org> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, hazelsct@debian.org (Adam C. Powell, IV):
Bug#195509; Package mpich. Full text and rfc822 format available.

Acknowledgement sent to Adam C Powell IV <hazelsct@debian.org>:
Extra info received and forwarded to list. Copy sent to hazelsct@debian.org (Adam C. Powell, IV). Full text and rfc822 format available.

Message #57 received at 195509@bugs.debian.org (full text, mbox):

From: Adam C Powell IV <hazelsct@debian.org>
To: 195509@bugs.debian.org, 301898@bugs.debian.org
Cc: 195509-submitter@bugs.debian.org, 301898-submitter@bugs.debian.org, control@bugs.debian.org
Subject: Re: Solved by gfortran-4.0?
Date: Wed, 19 Oct 2005 12:21:21 -0400
merge 195509 301898
thanks

Just an update: because gfortran and g77 do not produce
symbol-compatible objects (according to mpich configure), mpich refuses
to use gfortran for Fortran 90/95.  And because g77-3.4 is still the
recommended compiler for Fortran 77 code, use of Fortran 90/95 is on
hold until gfortran is sufficiently stable to be used for both sets of
code.

At that point, the change in symbol naming may force us to go through a
nasty Fortran transition like the C++ transition, but not quite as nasty
because there's not quite as much Fortran as C++ in Debian.

Cheers,
Adam

On Mon, 2005-07-11 at 13:57 -0400, Adam C Powell IV wrote:
> reassign 195509 mpich
> retitle 195509 Please support Fortran 90 using new gfortran
> thanks
> 
> Hello Konrad,
> 
> Thanks for the note on this bug.  I'm just now following up on my old
> bugs in my Debian bugs folder.
> 
> The bug was originally about mpich's lack of support for fortran 90.
> Now that gfortran-4.0 is in unstable, I'm reassigning it back to mpich
> (which I maintain).
> 
> Thanks,
-Adam
-- 
GPG fingerprint: D54D 1AEE B11C CE9B A02B  C5DD 526F 01E8 564E E4B6

Welcome to the best software in the world today cafe!
http://www.take6.com/albums/greatesthits.html



Message sent on to Egon Willighagen <egonw@sci.kun.nl>:
Bug#195509. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, hazelsct@debian.org (Adam C. Powell, IV):
Bug#195509; Package mpich. Full text and rfc822 format available.

Acknowledgement sent to wieseltux23 <gspurki@gmail.com>:
Extra info received and forwarded to list. Copy sent to hazelsct@debian.org (Adam C. Powell, IV). Full text and rfc822 format available.

Message #65 received at 195509@bugs.debian.org (full text, mbox):

From: wieseltux23 <gspurki@gmail.com>
To: Adam C Powell IV <hazelsct@debian.org>, 195509@bugs.debian.org
Cc: 301898@bugs.debian.org, 195509-submitter@bugs.debian.org, 301898-submitter@bugs.debian.org, control@bugs.debian.org
Subject: Re: Bug#195509: Solved by gfortran-4.0?
Date: Thu, 20 Oct 2005 17:19:25 +0200
Adam C Powell IV wrote:

>merge 195509 301898
>thanks
>
>Just an update: because gfortran and g77 do not produce
>symbol-compatible objects (according to mpich configure), mpich refuses
>to use gfortran for Fortran 90/95.  And because g77-3.4 is still the
>recommended compiler for Fortran 77 code, use of Fortran 90/95 is on
>hold until gfortran is sufficiently stable to be used for both sets of
>code.
>
>At that point, the change in symbol naming may force us to go through a
>nasty Fortran transition like the C++ transition, but not quite as nasty
>because there's not quite as much Fortran as C++ in Debian.
>
>Cheers,
>Adam
>
>On Mon, 2005-07-11 at 13:57 -0400, Adam C Powell IV wrote:
>  
>
>>reassign 195509 mpich
>>retitle 195509 Please support Fortran 90 using new gfortran
>>thanks
>>
>>Hello Konrad,
>>
>>Thanks for the note on this bug.  I'm just now following up on my old
>>bugs in my Debian bugs folder.
>>
>>The bug was originally about mpich's lack of support for fortran 90.
>>Now that gfortran-4.0 is in unstable, I'm reassigning it back to mpich
>>(which I maintain).
>>
>>Thanks,
>>    
>>
>-Adam
>  
>
TRY IT!! https://www.scientificlinux.org/



Message sent on to Egon Willighagen <egonw@sci.kun.nl>:
Bug#195509. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, hazelsct@debian.org (Adam C. Powell, IV):
Bug#195509; Package mpich. Full text and rfc822 format available.

Acknowledgement sent to Riku Voipio <riku.voipio@iki.fi>:
Extra info received and forwarded to list. Copy sent to hazelsct@debian.org (Adam C. Powell, IV). Full text and rfc822 format available.

Message #73 received at 195509@bugs.debian.org (full text, mbox):

From: Riku Voipio <riku.voipio@iki.fi>
To: 195509@bugs.debian.org
Cc: control@bugs.debian.org
Subject: Please support Fortran 90 using new gfortran
Date: Sat, 16 Jun 2007 18:23:38 +0300
user debian-arm@lists.debian.org
usertag 195509 + eabi
thanks

Hi,

Any news on this? g77 has been dropped from gcc after gcc-3.4,
and arm eabi port is included in gcc-4.1 earliest..

-- 
"rm -rf" only sounds scary if you don't have backups



Information forwarded to debian-bugs-dist@lists.debian.org, hazelsct@debian.org (Adam C. Powell, IV):
Bug#195509; Package mpich. Full text and rfc822 format available.

Acknowledgement sent to Adam C Powell IV <hazelsct@debian.org>:
Extra info received and forwarded to list. Copy sent to hazelsct@debian.org (Adam C. Powell, IV). Full text and rfc822 format available.

Message #78 received at 195509@bugs.debian.org (full text, mbox):

From: Adam C Powell IV <hazelsct@debian.org>
To: Riku Voipio <riku.voipio@iki.fi>, 195509@bugs.debian.org
Subject: Re: Bug#195509: Please support Fortran 90 using new gfortran
Date: Mon, 18 Jun 2007 10:56:18 -0400
On Sat, 2007-06-16 at 18:23 +0300, Riku Voipio wrote:
> user debian-arm@lists.debian.org
> usertag 195509 + eabi
> thanks
> 
> Hi,
> 
> Any news on this? g77 has been dropped from gcc after gcc-3.4,
> and arm eabi port is included in gcc-4.1 earliest..

No news, sorry, haven't tried it.  I'll mark this bug as a high priority
for my next upload, likely in the next couple of weeks.

Thanks,
-Adam
-- 
GPG fingerprint: D54D 1AEE B11C CE9B A02B  C5DD 526F 01E8 564E E4B6

Welcome to the best software in the world today cafe!
http://www.take6.com/albums/greatesthits.html




Information forwarded to debian-bugs-dist@lists.debian.org, hazelsct@debian.org (Adam C. Powell, IV):
Bug#195509; Package mpich. Full text and rfc822 format available.

Acknowledgement sent to Colin Tuckley <colin@tuckley.org>:
Extra info received and forwarded to list. Copy sent to hazelsct@debian.org (Adam C. Powell, IV). Full text and rfc822 format available.

Message #83 received at 195509@bugs.debian.org (full text, mbox):

From: Colin Tuckley <colin@tuckley.org>
To: 195509@bugs.debian.org
Subject: Re: Bug#195509: Please support Fortran 90 using new gfortran
Date: Thu, 13 Dec 2007 12:19:37 +0000
> No news, sorry, haven't tried it.  I'll mark this bug as a high priority
> for my next upload, likely in the next couple of weeks.

Any further news on this? mpich is now one of the blocking libs for the ARM
eabi arch in Lenny.

-- 
Colin Tuckley      |  +44(0)1903 236872  |  PGP/GnuPG Key Id
Debian Developer   |  +44(0)7799 143369  |     0x1B3045CE

Try to learn from other people's mistakes, you haven't time to make them all
yourself! - Anon




Information forwarded to debian-bugs-dist@lists.debian.org, hazelsct@debian.org (Adam C. Powell, IV):
Bug#195509; Package mpich. Full text and rfc822 format available.

Acknowledgement sent to Adam C Powell IV <hazelsct@debian.org>:
Extra info received and forwarded to list. Copy sent to hazelsct@debian.org (Adam C. Powell, IV). Full text and rfc822 format available.

Message #88 received at 195509@bugs.debian.org (full text, mbox):

From: Adam C Powell IV <hazelsct@debian.org>
To: Colin Tuckley <colin@tuckley.org>, 195509@bugs.debian.org
Subject: Re: Bug#195509: Please support Fortran 90 using new gfortran
Date: Wed, 19 Dec 2007 12:46:00 -0500
On Thu, 2007-12-13 at 12:19 +0000, Colin Tuckley wrote:
> > No news, sorry, haven't tried it.  I'll mark this bug as a high priority
> > for my next upload, likely in the next couple of weeks.
> 
> Any further news on this? mpich is now one of the blocking libs for the ARM
> eabi arch in Lenny.

Hello,

I tried this in July; the issue is that gfortran does not provide a
standard GETARG symbol.  See the discussion at:
http://lists.debian.org/debian-toolchain/2007/07/msg00012.html

I haven't heard anything further since July, so I don't think this
problem has gone away.  I'm mentoring a new maintainer for mpich who may
be able to get a workaround together.

Cheers,
-Adam
-- 
GPG fingerprint: D54D 1AEE B11C CE9B A02B  C5DD 526F 01E8 564E E4B6

Engineering consulting with open source tools
http://www.opennovation.com/





Information forwarded to debian-bugs-dist@lists.debian.org, hazelsct@debian.org (Adam C. Powell, IV):
Bug#195509; Package mpich. Full text and rfc822 format available.

Acknowledgement sent to Kumar Appaiah <akumar@ee.iitm.ac.in>:
Extra info received and forwarded to list. Copy sent to hazelsct@debian.org (Adam C. Powell, IV). Full text and rfc822 format available.

Message #93 received at 195509@bugs.debian.org (full text, mbox):

From: Kumar Appaiah <akumar@ee.iitm.ac.in>
To: 195509@bugs.debian.org, doko@debian.org, riku@debian.org, colint@debian.org
Subject: Proceeding on this bug.
Date: Wed, 30 Jan 2008 01:09:27 +0530
[Message part 1 (text/plain, inline)]
Hi!

Based on Tobias Burnus advice on:

http://thread.gmane.org/gmane.linux.debian.devel.toolchain/733/focus=22611

I have been able to make a patch for mpich which sort of proceeds with
the build using gfortran (I have fixed it to gfortran-4.3). However,
the build fails at a later stage.

Attached is my patch, and the build log. The relevant parts are here:

<log>
Fortran subsystem:

Configuring Fortran subsystem
checking for cc... cc
checking whether the C compiler sets its return status correctly... yes
checking for an ANSI C-conforming const... no
checking for Fortran 77 compiler default output file name... a.out
checking whether the Fortran 77 compiler works... yes
checking whether we are cross compiling... no
checking for suffix of executables... 
checking for suffix of object files... o
checking whether we are using the GNU Fortran 77 compiler... yes
checking whether gfortran-4.3 accepts -g... yes

[snip]

checking that f works as the extension for Fortran 90 program... no
checking for extension for Fortran 90 programs... unknown!

[snip]

checking for routines to access the command line from Fortran 77... searching...
checking whether gfortran-4.3   works with GETARG and IARGC... yes
checking how to get verbose linking output from gfortran-4.3 ... -v
checking for Fortran libraries of gfortran-4.3 ...  -L/usr/lib/gcc/x86_64-linux-gnu/4.3.0 -L/usr/lib/gcc/x86_64-linux-gnu/4.3.0/../../../../lib -L/lib/../lib -L/usr/lib/../lib -L/usr/lib/gcc/x86_64-linux-gnu/4.3.0/../../.. -lgfortranbegin -lgfortran -lm -lgcc_s
checking whether C can link with  -L/usr/lib/gcc/x86_64-linux-gnu/4.3.0 -L/usr/lib/gcc/x86_64-linux-gnu/4.3.0/../../../../lib -L/lib/../lib -L/usr/lib/../lib -L/usr/lib/gcc/x86_64-linux-gnu/4.3.0/../../.. -lgfortranbegin -lgfortran -lm -lgcc_s... yes
checking for linker for Fortran main programs... Use Fortran to link programs
checking for Fortran 77 name mangling... lower underscore
checking for which Fortran libraries are needed to link C with Fortran... none
checking whether Fortran accepts ! for comments... yes
checking for include directory flag for Fortran... -I
checking for Fortran 77 flag for library directories... -L
checking whether Fortran has pointer declaration... no
checking for size of Fortran type integer... 4
checking for size of Fortran type real... 4
checking for size of Fortran type double precision... 8

[snip]

checking for C type matching Fortran integer*1... char
checking for C type matching Fortran integer*2... short
checking for C type matching Fortran integer*4... int
checking for C type matching Fortran integer*8... long
checking for C type matching Fortran integer*16... unavailable
checking for C type matching Fortran real*4... float
checking for C type matching Fortran real*8... double
checking for C type matching Fortran integer... int
checking whether C compiler allows unaligned doubles... yes
checking for type of weak symbol support... pragma weak
checking whether __attribute__ ((weak)) allowed... yes
checking for values of Fortran logicals... True is 1 and False is 0
checking for Fortran 90 integer kind for 8-byte integers... unavailable
checking for Fortran 90 integer kind for 8-byte integers... -1 (cached)
checking for Fortran 90 integer kind for 4-byte integers... unavailable
configure: WARNING: Unable to determine the size of a simple integer
configure: WARNING: Using 4 for the Fortran 90 KIND of an MPI_Aint
configure: WARNING: Using 4 for the Fortran 90 KIND of an MPI_Offset
checking whether using gcc and g77 together... no

[snip]

Done configuring Fortran subsystem
</log>

The failure step is this:
<fail>
/tmp/buildd/mpich-1.2.7/image_mpich/bin/mpicc -DMPI_LINUX -DUSE_STDARG -DHAVE_PROTOTYPES  -DMPE_GRAPHICS -I.. -I/tmp/buildd/mpich-1.2.7/mpe/include -I../slog_api -I/tmp/buildd/mpich-1.2.7/mpe/slog_api/include   -DUSE_SOCKLEN_T -DUSE_U_INT_FOR_XDR -DHAVE_MPICHCONF_H -fPIC -c /tmp/buildd/mpich-1.2.7/mpe/src/decompf.c -o decompf.lo
/tmp/buildd/mpich-1.2.7/image_mpich/bin/mpicc -DMPI_LINUX -DUSE_STDARG -DHAVE_PROTOTYPES  -DMPE_GRAPHICS -I.. -I/tmp/buildd/mpich-1.2.7/mpe/include -I../slog_api -I/tmp/buildd/mpich-1.2.7/mpe/slog_api/include   -DUSE_SOCKLEN_T -DUSE_U_INT_FOR_XDR -DHAVE_MPICHCONF_H -fPIC -c /tmp/buildd/mpich-1.2.7/mpe/src/mpe_seqf.c -o mpe_seqf.lo
/tmp/buildd/mpich-1.2.7/image_mpich/bin/mpicc -DMPI_LINUX -DUSE_STDARG -DHAVE_PROTOTYPES  -DMPE_GRAPHICS -I.. -I/tmp/buildd/mpich-1.2.7/mpe/include -I../slog_api -I/tmp/buildd/mpich-1.2.7/mpe/slog_api/include   -DUSE_SOCKLEN_T -DUSE_U_INT_FOR_XDR -DHAVE_MPICHCONF_H -fPIC -c /tmp/buildd/mpich-1.2.7/mpe/src/getgrankf.c -o getgrankf.lo
if [ ! -d /tmp/buildd/mpich-1.2.7/image_mpich/mpe/lib/shared ]; then mkdir /tmp/buildd/mpich-1.2.7/image_mpich/mpe/lib/shared; fi
cc -shared -Wl,-z,defs -Wl,-soname,libmpe.so.1.0 -o /tmp/buildd/mpich-1.2.7/image_mpich/mpe/lib/shared/libmpe.so.1.0 mpe_graphics.lo xcolor.lo xframe.lo xinit.lo xwmap.lo xmouse.lo xkey.lo clog_sysio.lo mpe_log.lo clog.lo clog_merge.lo clog_time.lo clog_util.lo clog2alog.lo decomp.lo mpe_seq.lo dbxerr.lo examine.lo privtags.lo getgrank.lo mpehname.lo mpe_io.lo mpe_graphicsf.lo xmousef.lo mpe_logf.lo decompf.lo mpe_seqf.lo getgrankf.lo -L /usr/X11R6/lib -lX11 -lm -L../../lib/shared -l`echo mpe | sed -e 's/^mpe/mpich/'`
/usr/bin/ld: cannot find -lmpich
collect2: ld returned 1 exit status
make[6]: *** [/tmp/buildd/mpich-1.2.7/image_mpich/mpe/lib/shared/libmpe.so] Error 1
make[5]: *** [default] Error 2
make[4]: *** [build_libs_progs] Error 2
make[3]: *** [mpelib] Error 1
make[2]: *** [mpi-addons] Error 2
make[1]: *** [mpi] Error 2
make[1]: Leaving directory `/tmp/buildd/mpich-1.2.7/image_mpich'
make: *** [build-stamp] Error 2
dpkg-buildpackage: failure: debian/rules build gave error exit status 2
</fail>

Hope this helps make some progress.

Thanks.

Kumar
-- 
Kumar Appaiah,
458, Jamuna Hostel,
Indian Institute of Technology Madras,
Chennai - 600 036
[mpich_gf.diff (text/x-diff, attachment)]
[mpich_1.2.7-5.1_amd64.build.gz (application/octet-stream, attachment)]
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, hazelsct@debian.org (Adam C. Powell, IV):
Bug#195509; Package mpich. Full text and rfc822 format available.

Acknowledgement sent to Adam C Powell IV <hazelsct@debian.org>:
Extra info received and forwarded to list. Copy sent to hazelsct@debian.org (Adam C. Powell, IV). Full text and rfc822 format available.

Message #98 received at 195509@bugs.debian.org (full text, mbox):

From: Adam C Powell IV <hazelsct@debian.org>
To: Kumar Appaiah <akumar@ee.iitm.ac.in>, 195509@bugs.debian.org
Cc: doko@debian.org, riku@debian.org, colint@debian.org
Subject: Re: Bug#195509: Proceeding on this bug.
Date: Wed, 30 Jan 2008 13:45:40 -0500
On Wed, 2008-01-30 at 01:09 +0530, Kumar Appaiah wrote:
> Hi!
> 
> Based on Tobias Burnus advice on:
> 
> http://thread.gmane.org/gmane.linux.debian.devel.toolchain/733/focus=22611
> 
> I have been able to make a patch for mpich which sort of proceeds with
> the build using gfortran (I have fixed it to gfortran-4.3).

Excellent, thanks very much for the patch and for your help!

> However,
> the build fails at a later stage.
> 
> Attached is my patch, and the build log. The relevant parts are here:

You missed a very relevant part:
<log>
checking whether C compiler accepts option -fPIC... yes
checking whether routines compiled with -fPIC can be linked with ones compiled  without -fPIC... yes
checking whether Fortran compiler accepts option -PIC... no
checking whether Fortran compiler accepts option -fPIC... yes
checking whether routines compiled with -fPIC can be linked with ones compiled without -fPIC... yes
checking for argument used to indicate shared lib search dir... -Wl,-rpath -Wl,
checking whether shared libraries can be built... no
Running device-specific setup program

[snip]

ranlib libpmpi++.a
Making all in balky
make[5]: Nothing to be done for `all'.
make[5]: Nothing to be done for `all-am'.
make --no-print-directory mpi-lib-test
make --no-print-directory profileliblink
Testing that MPI applications can be linked...
make --no-print-directory linktest
make overtake
/tmp/buildd/mpich-1.2.7/image_mpich/bin/mpicc -DUSE_SOCKLEN_T -DUSE_U_INT_FOR_XDR -DHAVE_MPICHCONF_H  -DHAVE_STDLIB_H=1 -DHAVE_UNISTD_H=1 -DHAVE_STRING_H=1 -DUSE_STDARG=1 -DHAVE_LONG_DOUBLE=1 -DHAVE_LONG_LONG_INT=1 -DHAVE_PROTOTYPES=1 -DHAVE_SIGNAL_H=1 -DHAVE_SIGACTION=1 -DHAVE_SLEEP=1 -DHAVE_SYSCONF=1   -c /tmp/buildd/mpich-1.2.7/examples/test/pt2pt/overtake.c
/tmp/buildd/mpich-1.2.7/image_mpich/bin/mpicc -DUSE_SOCKLEN_T -DUSE_U_INT_FOR_XDR -DHAVE_MPICHCONF_H  -DHAVE_STDLIB_H=1 -DHAVE_UNISTD_H=1 -DHAVE_STRING_H=1 -DUSE_STDARG=1 -DHAVE_LONG_DOUBLE=1 -DHAVE_LONG_LONG_INT=1 -DHAVE_PROTOTYPES=1 -DHAVE_SIGNAL_H=1 -DHAVE_SIGACTION=1 -DHAVE_SLEEP=1 -DHAVE_SYSCONF=1   -c /tmp/buildd/mpich-1.2.7/examples/test/pt2pt/test.c
/tmp/buildd/mpich-1.2.7/image_mpich/bin/mpicc  -o overtake overtake.o test.o 
make clean
make --no-print-directory mpi-addons
make --no-print-directory mpelib        
Making MPE Profiling Libraries
</log>

Compare with the -5 i386 build log:

<log>
checking whether C compiler accepts option -fPIC... yes
checking whether routines compiled with -fPIC can be linked with ones compiled  without -fPIC... yes
checking whether Fortran compiler accepts option -PIC... no
checking whether Fortran compiler accepts option -fPIC... yes
checking whether routines compiled with -fPIC can be linked with ones compiled without -fPIC... yes
checking for argument used to indicate shared lib search dir... -Wl,-rpath -Wl,
checking whether shared libraries can be built... yes
checking whether programs remember where the shared lib is... yes
Running device-specific setup program

[snip]

ranlib libpmpi++.a
Making all in balky
make[5]: Nothing to be done for `all'.
make[5]: Nothing to be done for `all-am'.
make --no-print-directory mpi-lib-test
make --no-print-directory profileliblink
Testing that MPI applications can be linked...
make --no-print-directory linktest
make overtake
/build/buildd/mpich-1.2.7/image_mpich/bin/mpicc -fPIC -DUSE_SOCKLEN_T -DUSE_U_INT_FOR_XDR -DHAVE_MPICHCONF_H  -DHAVE_STDLIB_H=1 -DHAVE_UNISTD_H=1 -DHAVE_STRING_H=1 -DUSE_STDARG=1 -DHAVE_LONG_DOUBLE=1 -DHAVE_LONG_LONG_INT=1 -DHAVE_PROTOTYPES=1 -DHAVE_SIGNAL_H=1 -DHAVE_SIGACTION=1 -DHAVE_SLEEP=1 -DHAVE_SYSCONF=1   -c /build/buildd/mpich-1.2.7/examples/test/pt2pt/overtake.c
/build/buildd/mpich-1.2.7/image_mpich/bin/mpicc -fPIC -DUSE_SOCKLEN_T -DUSE_U_INT_FOR_XDR -DHAVE_MPICHCONF_H  -DHAVE_STDLIB_H=1 -DHAVE_UNISTD_H=1 -DHAVE_STRING_H=1 -DUSE_STDARG=1 -DHAVE_LONG_DOUBLE=1 -DHAVE_LONG_LONG_INT=1 -DHAVE_PROTOTYPES=1 -DHAVE_SIGNAL_H=1 -DHAVE_SIGACTION=1 -DHAVE_SLEEP=1 -DHAVE_SYSCONF=1   -c /build/buildd/mpich-1.2.7/examples/test/pt2pt/test.c
/build/buildd/mpich-1.2.7/image_mpich/bin/mpicc  -o overtake overtake.o test.o 
make clean
make --no-print-directory mpi-addons
Making a shared library of libmpich.a
Successfully linked libmpich.a
Making a shared library of libpmpich.a
Successfully linked libpmpich.a
Making a shared library of libfmpich.a
Successfully linked libfmpich.a
Making a shared library of libpmpich++.a
Successfully linked libpmpich++.a
Testing that MPI applications can be linked with shared libs...
make overtake
/build/buildd/mpich-1.2.7/image_mpich/bin/mpicc -fPIC -DUSE_SOCKLEN_T -DUSE_U_INT_FOR_XDR -DHAVE_MPICHCONF_H  -DHAVE_STDLIB_H=1 -DHAVE_UNISTD_H=1 -DHAVE_STRING_H=1 -DUSE_STDARG=1 -DHAVE_LONG_DOUBLE=1 -DHAVE_LONG_LONG_INT=1 -DHAVE_PROTOTYPES=1 -DHAVE_SIGNAL_H=1 -DHAVE_SIGACTION=1 -DHAVE_SLEEP=1 -DHAVE_SYSCONF=1   -c /build/buildd/mpich-1.2.7/examples/test/pt2pt/overtake.c
/build/buildd/mpich-1.2.7/image_mpich/bin/mpicc -fPIC -DUSE_SOCKLEN_T -DUSE_U_INT_FOR_XDR -DHAVE_MPICHCONF_H  -DHAVE_STDLIB_H=1 -DHAVE_UNISTD_H=1 -DHAVE_STRING_H=1 -DUSE_STDARG=1 -DHAVE_LONG_DOUBLE=1 -DHAVE_LONG_LONG_INT=1 -DHAVE_PROTOTYPES=1 -DHAVE_SIGNAL_H=1 -DHAVE_SIGACTION=1 -DHAVE_SLEEP=1 -DHAVE_SYSCONF=1   -c /build/buildd/mpich-1.2.7/examples/test/pt2pt/test.c
/build/buildd/mpich-1.2.7/image_mpich/bin/mpicc  -o overtake overtake.o test.o 
make clean
make --no-print-directory mpelib        
Making MPE Profiling Libraries
</log>

It's not even trying to make the mpich shared lib.  It's a bug that it's
trying to make the shared MPE lib even so.  But that's not our concern.

Can you see what is going on in config.log which makes configure believe
that it can't make shared libraries?

Thanks,
-Adam
-- 
GPG fingerprint: D54D 1AEE B11C CE9B A02B  C5DD 526F 01E8 564E E4B6

Engineering consulting with open source tools
http://www.opennovation.com/





Information forwarded to debian-bugs-dist@lists.debian.org, hazelsct@debian.org (Adam C. Powell, IV):
Bug#195509; Package mpich. Full text and rfc822 format available.

Acknowledgement sent to Kumar Appaiah <akumar@ee.iitm.ac.in>:
Extra info received and forwarded to list. Copy sent to hazelsct@debian.org (Adam C. Powell, IV). Full text and rfc822 format available.

Message #103 received at 195509@bugs.debian.org (full text, mbox):

From: Kumar Appaiah <akumar@ee.iitm.ac.in>
To: Adam C Powell IV <hazelsct@debian.org>
Cc: 195509@bugs.debian.org, doko@debian.org, riku@debian.org, colint@debian.org
Subject: Re: Bug#195509: Proceeding on this bug.
Date: Thu, 31 Jan 2008 07:24:05 +0530
[Message part 1 (text/plain, inline)]
Dear Adam,

On Wed, Jan 30, 2008 at 01:45:40PM -0500, Adam C Powell IV wrote:
> > However,
> > the build fails at a later stage.
> > 
> > Attached is my patch, and the build log. The relevant parts are here:
> 
> You missed a very relevant part:

[snipping]

> It's not even trying to make the mpich shared lib.  It's a bug that it's
> trying to make the shared MPE lib even so.  But that's not our concern.

I appreciate your eye for detail. The reason was visible from
config.log:

Failed to build shared library
/usr/bin/ld: cannot find -lg2c
collect2: ld returned 1 exit status
Linking libconftest.a shared lib failed 

Oh duh! -lg2c was the issue! :-)

So, I fumbled around with the dpatches, and have this now in the logs:

<log>
checking whether routines compiled with -fPIC can be linked with ones compiled  without -fPIC... yes
checking whether Fortran compiler accepts option -PIC... no
checking whether Fortran compiler accepts option -fPIC... yes
checking whether routines compiled with -fPIC can be linked with ones compiled without -fPIC... yes
checking for argument used to indicate shared lib search dir... -Wl,-rpath -Wl,
checking whether shared libraries can be built... yes
checking whether programs remember where the shared lib is... yes
</log>

And later:
<log>
cc -shared -Wl,-z,defs -Wl,-soname,libmpe.so.1.0 -o /tmp/buildd/mpich-1.2.7/image_mpich/mpe/lib/shared/libmpe.so.1.0 mpe_graphics.lo xcolor.lo xframe.lo xinit.lo xwmap.lo xmouse.lo xkey.lo clog_sysio.lo mpe_log.lo clog.lo clog_merge.lo clog_time.lo clog_util.lo clog2alog.lo decomp.lo mpe_seq.lo dbxerr.lo examine.lo privtags.lo getgrank.lo mpehname.lo mpe_io.lo mpe_graphicsf.lo xmousef.lo mpe_logf.lo decompf.lo mpe_seqf.lo getgrankf.lo -L /usr/X11R6/lib -lX11 -lm -L../../lib/shared -l`echo mpe | sed -e 's/^mpe/mpich/'`
ln -sf libmpe.so.1.0 /tmp/buildd/mpich-1.2.7/image_mpich/mpe/lib/shared/libmpe.so
</log>

The above succeeds. However, some time later:
<log>
/tmp/buildd/mpich-1.2.7/image_mpich-mpd/bin/mpicc -DMPI_LINUX -DUSE_STDARG -DHAVE_PROTOTYPES  -DMPE_GRAPHICS -I.. -I/tmp/buildd/mpich-1.2.7/mpe/include -I../slog_api -I/tmp/buildd/mpich-1.2.7/mpe/slog_api/include  -fPIC  -DUSE_SOCKLEN_T -DUSE_U_INT_FOR_XDR -DHAVE_MPICHCONF_H -fPIC -c /tmp/buildd/mpich-1.2.7/mpe/src/getgrankf.c -o getgrankf.lo
if [ ! -d /tmp/buildd/mpich-1.2.7/image_mpich-mpd/mpe/lib/shared ]; then mkdir /tmp/buildd/mpich-1.2.7/image_mpich-mpd/mpe/lib/shared; fi
cc -shared -Wl,-z,defs -Wl,-soname,libmpe.so.1.0 -o /tmp/buildd/mpich-1.2.7/image_mpich-mpd/mpe/lib/shared/libmpe.so.1.0 mpe_graphics.lo xcolor.lo xframe.lo xinit.lo xwmap.lo xmouse.lo xkey.lo clog_sysio.lo mpe_log.lo clog.lo clog_merge.lo clog_time.lo clog_util.lo clog2alog.lo decomp.lo mpe_seq.lo dbxerr.lo examine.lo privtags.lo getgrank.lo mpehname.lo mpe_io.lo mpe_graphicsf.lo xmousef.lo mpe_logf.lo decompf.lo mpe_seqf.lo getgrankf.lo -L /usr/X11R6/lib -lX11 -lm -L../../lib/shared -l`echo mpe | sed -e 's/^mpe/mpich/'`
/usr/bin/ld: cannot find -lmpich
collect2: ld returned 1 exit status
make[6]: *** [/tmp/buildd/mpich-1.2.7/image_mpich-mpd/mpe/lib/shared/libmpe.so] Error 1
make[5]: *** [default] Error 2
make[4]: *** [build_libs_progs] Error 2
make[3]: *** [mpelib] Error 1
make[2]: *** [mpi-addons] Error 2
make[1]: *** [mpi] Error 2
make[1]: Leaving directory `/tmp/buildd/mpich-1.2.7/image_mpich-mpd'
make: *** [build-stamp] Error 2
dpkg-buildpackage: failure: debian/rules build gave error exit status 2
</log>

I could not proceed further. I have attached complete logs, and a new
patch which fixes some further aspects. Should you want me to check
anything more, do tell me.

Thanks!

Kumar
-- 
Kumar Appaiah,
458, Jamuna Hostel,
Indian Institute of Technology Madras,
Chennai - 600 036
[old_config.log (text/plain, attachment)]
[mpich_fix_2.diff (text/x-diff, attachment)]
[mpich_1.2.7-5.1_amd64.build.gz (application/octet-stream, attachment)]
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, hazelsct@debian.org (Adam C. Powell, IV):
Bug#195509; Package mpich. Full text and rfc822 format available.

Acknowledgement sent to Kumar Appaiah <akumar@ee.iitm.ac.in>:
Extra info received and forwarded to list. Copy sent to hazelsct@debian.org (Adam C. Powell, IV). Full text and rfc822 format available.

Message #108 received at 195509@bugs.debian.org (full text, mbox):

From: Kumar Appaiah <akumar@ee.iitm.ac.in>
To: Adam C Powell IV <hazelsct@debian.org>
Cc: 195509@bugs.debian.org, doko@debian.org, riku@debian.org, colint@debian.org
Subject: Re: Bug#195509: Proceeding on this bug.
Date: Thu, 31 Jan 2008 08:12:20 +0530
[Message part 1 (text/plain, inline)]
On Thu, Jan 31, 2008 at 07:24:05AM +0530, Kumar Appaiah wrote:
> Dear Adam,
> 
> On Wed, Jan 30, 2008 at 01:45:40PM -0500, Adam C Powell IV wrote:
> > > However,
> > > the build fails at a later stage.
> > > 
> > > Attached is my patch, and the build log. The relevant parts are here:
> > 
> > You missed a very relevant part:

Er, apologies for the previous post... it failed due to getarg, in all
likelihood. I missed reading the logs properly.

I shall give it one more try when I have time.

Sorry.

Kumar
-- 
Kumar Appaiah,
458, Jamuna Hostel,
Indian Institute of Technology Madras,
Chennai - 600 036
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, hazelsct@debian.org (Adam C. Powell, IV):
Bug#195509; Package mpich. Full text and rfc822 format available.

Acknowledgement sent to Kumar Appaiah <akumar@ee.iitm.ac.in>:
Extra info received and forwarded to list. Copy sent to hazelsct@debian.org (Adam C. Powell, IV). Full text and rfc822 format available.

Message #113 received at 195509@bugs.debian.org (full text, mbox):

From: Kumar Appaiah <akumar@ee.iitm.ac.in>
To: Adam C Powell IV <hazelsct@debian.org>
Cc: 195509@bugs.debian.org, doko@debian.org, riku@debian.org, colint@debian.org
Subject: Re: Bug#195509: Proceeding on this bug.
Date: Thu, 31 Jan 2008 09:25:30 +0530
[Message part 1 (text/plain, inline)]
On Thu, Jan 31, 2008 at 08:12:19AM +0530, Kumar Appaiah wrote:
> On Thu, Jan 31, 2008 at 07:24:05AM +0530, Kumar Appaiah wrote:
> > Dear Adam,
> > 
> > On Wed, Jan 30, 2008 at 01:45:40PM -0500, Adam C Powell IV wrote:
> > > > However,
> > > > the build fails at a later stage.
> > > > 
> > > > Attached is my patch, and the build log. The relevant parts are here:
> > > 
> > > You missed a very relevant part:
> 
> Er, apologies for the previous post... it failed due to getarg, in all
> likelihood. I missed reading the logs properly.
> 
> I shall give it one more try when I have time.

OK, I gave it one more shot, and I haven't solved it fully yet, but
this time, I believe that many issues are solved.

First, I fixed the -lg2c stuff in your patches. Then, I started
getting errors like these:

farg.o: In function `mpir_iargc_':
farg.f:(.text+0x9): undefined reference to `_gfortran_iargc'
farg.o: In function `mpir_getarg_':
farg.f:(.text+0x39): undefined reference to `_gfortran_getarg_i4'
collect2: ld returned 1 exit status

Naturally, using gcc to link these files fails since they were
compiled with gfortran using F77_GETARGDECL="intrinsic GETARG" in the
environment. So, I tried putting this environment variable, though the
link still failed, as this environment variable is useless unless
gfortran is used. But changing the linker to gfortran fails because
C++ code doesn't link (I got some missing -lstdc++ errors). So, I
edited one of your dpatches to make the following change in
util/makesharedlib:

@@ -170,7 +170,10 @@
         libbase=`basename $libname .a`
 	# The -h name sets the name of the object; this is necessary to 
 	# ensure that the dynamic linker can find the proper shared library.
-        if $CLINKER -shared -Wl,-h,$libbase.$slsuffix -o ../shared/$libbase.$slsuffix *.o $OtherLibs ; then
+        export F77_GETARGDECL="intrinsic GETARG"
+	if $CLINKER -shared -Wl,-h,$libbase.$slsuffix -o ../shared/$libbase.$slsuffix *.o $OtherLibs ; then
+	    echo Successfully linked $libname
+	elif gfortran-4.3 -shared -Wl,-h,$libbase.$slsuffix -o ../shared/$libbase.$slsuffix *.o $OtherLibs ; then
 	    echo Successfully linked $libname
 	else
 	    echo "Linking $libname shared lib failed " 

This is certainly not good, but seems to work. Maybe you can refine
it. This is also the reason why you see the getarg errors interspersed
in the build logs.

Now, the failure is this:
cc -DHAVE_CONFIG_H -I. -I/tmp/buildd/mpich-1.2.7/mpid/ch_p4mpd -I/tmp/buildd/mpich-1.2.7/include -I/tmp/buildd/mpich-1.2.7/image_mpich-mpd/include -I/tmp/buildd/mpich-1.2.7/image_mpich-mpd/mpid/ch_p4mpd -I/tmp/buildd/mpich-1.2.7/mpid/util -I/tmp/buildd/mpich-1.2.7/mpid/ch_p4mpd -DHAVE_MPICH_MPID_H -DMPID_DEVICE_CODE  -DHAVE_UNAME=1 -DHAVE_NETDB_H=1 -DHAVE_GETHOSTBYNAME=1  -DMPID_DEBUG_NONE -DMPID_STAT_NONE  -fPIC  -DUSE_SOCKLEN_T -DUSE_U_INT_FOR_XDR -DHAVE_MPICHCONF_H -I/tmp/buildd/mpich-1.2.7/mpid/ch2 -I/tmp/buildd/mpich-1.2.7/mpid/ch_p4mpd -I/tmp/buildd/mpich-1.2.7/mpid/util -Ip4mpd -Ip4mpd/include  -c adi2recv.c 
In file included from /tmp/buildd/mpich-1.2.7/image_mpich-mpd/include/mpidefs.h:49,
                 from /tmp/buildd/mpich-1.2.7/include/mpi.h:230,
                 from mpid.h:18,
                 from adi2recv.c:8:
/tmp/buildd/mpich-1.2.7/image_mpich-mpd/include/mpio.h:248: warning: parameter names (without types) in function declaration
/tmp/buildd/mpich-1.2.7/image_mpich-mpd/include/mpio.h:249: error: expected '=', ',', ';', 'asm' or '__attribute__' before 'MPI_File_c2f'
/tmp/buildd/mpich-1.2.7/image_mpich-mpd/include/mpio.h:264: error: expected '=', ',', ';', 'asm' or '__attribute__' before 'MPIO_Request_c2f'
/tmp/buildd/mpich-1.2.7/image_mpich-mpd/include/mpio.h:265: warning: parameter names (without types) in function declaration
/tmp/buildd/mpich-1.2.7/image_mpich-mpd/include/mpio.h:418: warning: parameter names (without types) in function declaration
/tmp/buildd/mpich-1.2.7/image_mpich-mpd/include/mpio.h:419: error: expected '=', ',', ';', 'asm' or '__attribute__' before 'PMPI_File_c2f'
/tmp/buildd/mpich-1.2.7/image_mpich-mpd/include/mpio.h:432: error: expected '=', ',', ';', 'asm' or '__attribute__' before 'PMPIO_Request_c2f'
/tmp/buildd/mpich-1.2.7/image_mpich-mpd/include/mpio.h:433: warning: parameter names (without types) in function declaration
In file included from mpid.h:18,
                 from adi2recv.c:8:
/tmp/buildd/mpich-1.2.7/include/mpi.h:476: error: expected ')' before '*' token
/tmp/buildd/mpich-1.2.7/include/mpi.h:477: error: expected declaration specifiers or '...' before 'MPI_Fint'
/tmp/buildd/mpich-1.2.7/include/mpi.h:494: error: expected '=', ',', ';', 'asm' or '__attribute__' before 'MPI_Info_c2f'
/tmp/buildd/mpich-1.2.7/include/mpi.h:495: warning: parameter names (without types) in function declaration
/tmp/buildd/mpich-1.2.7/include/mpi.h:496: error: expected '=', ',', ';', 'asm' or '__attribute__' before 'MPI_Request_c2f'
/tmp/buildd/mpich-1.2.7/include/mpi.h:648: error: expected '=', ',', ';', 'asm' or '__attribute__' before 'PMPI_Info_c2f'
/tmp/buildd/mpich-1.2.7/include/mpi.h:649: warning: parameter names (without types) in function declaration
make[4]: *** [adi2recv.o] Error 1
Exit status from make was 2
make[3]: *** [mpilib] Error 1
make[2]: *** [mpi-modules] Error 2
make[1]: *** [mpi] Error 2
make[1]: Leaving directory `/tmp/buildd/mpich-1.2.7/image_mpich-mpd'
make: *** [build-stamp] Error 2
dpkg-buildpackage: failure: debian/rules build gave error exit status 2

I have no idea on how to handle this. My observation is that the lines
in question are related to some "f2c" and "c2f". For example, the
lines in question in mpi.h are:
/* misc2 (MPI2) */
int MPI_Status_f2c( MPI_Fint *, MPI_Status * );
int MPI_Status_c2f( MPI_Status *, MPI_Fint * );

MPI_Fint MPI_Info_c2f(MPI_Info);
MPI_Info MPI_Info_f2c(MPI_Fint);
MPI_Fint MPI_Request_c2f( MPI_Request );

MPI_Fint PMPI_Info_c2f(MPI_Info);
MPI_Info PMPI_Info_f2c(MPI_Fint);

I hope this is enough to proceed. I'd be glad to help out if you have
ideas, though.

Thanks.

Kumar
-- 
Kumar Appaiah,
458, Jamuna Hostel,
Indian Institute of Technology Madras,
Chennai - 600 036
[mpich_1.2.7-5.1_amd64.build.gz (application/octet-stream, attachment)]
[mpich_fix_2.diff (text/x-diff, attachment)]
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, hazelsct@debian.org (Adam C. Powell, IV):
Bug#195509; Package mpich. Full text and rfc822 format available.

Acknowledgement sent to Kumar Appaiah <akumar@ee.iitm.ac.in>:
Extra info received and forwarded to list. Copy sent to hazelsct@debian.org (Adam C. Powell, IV). Full text and rfc822 format available.

Message #118 received at 195509@bugs.debian.org (full text, mbox):

From: Kumar Appaiah <akumar@ee.iitm.ac.in>
To: Adam C Powell IV <hazelsct@debian.org>
Cc: 195509@bugs.debian.org, doko@debian.org, riku@debian.org, colint@debian.org
Subject: Re: Bug#195509: Proceeding on this bug.
Date: Thu, 31 Jan 2008 11:36:48 +0530
[Message part 1 (text/plain, inline)]
# Bcc'ing control
severity 195509 important
tags 195509 + patch
thanks

On Thu, Jan 31, 2008 at 09:25:30AM +0530, Kumar Appaiah wrote:
> @@ -170,7 +170,10 @@
>          libbase=`basename $libname .a`
>  	# The -h name sets the name of the object; this is necessary to 
>  	# ensure that the dynamic linker can find the proper shared library.
> -        if $CLINKER -shared -Wl,-h,$libbase.$slsuffix -o ../shared/$libbase.$slsuffix *.o $OtherLibs ; then
> +        export F77_GETARGDECL="intrinsic GETARG"
> +	if $CLINKER -shared -Wl,-h,$libbase.$slsuffix -o ../shared/$libbase.$slsuffix *.o $OtherLibs ; then
> +	    echo Successfully linked $libname
> +	elif gfortran-4.3 -shared -Wl,-h,$libbase.$slsuffix -o ../shared/$libbase.$slsuffix *.o $OtherLibs ; then
>  	    echo Successfully linked $libname
>  	else
>  	    echo "Linking $libname shared lib failed " 
> 
> This is certainly not good, but seems to work. Maybe you can refine
> it. This is also the reason why you see the getarg errors interspersed
> in the build logs.
> 
> Now, the failure is this:

[snip]

> I have no idea on how to handle this. My observation is that the lines
> in question are related to some "f2c" and "c2f". For example, the
> lines in question in mpi.h are:

[snip more]

Further diagnosis showed that these are the error causing lines, along
with the fixes:

diff -u mpich-1.2.7/src/fortran/configure mpich-1.2.7/src/fortran/configure
--- mpich-1.2.7/src/fortran/configure
+++ mpich-1.2.7/src/fortran/configure
@@ -15820,11 +15820,11 @@
 	    # turn off f90
 	    F90=""
 	else
- 	    F90_MODINCFLAG="`$MAKE -f ../../f90modules/Makefile f90modflag`"
-  	    F90MODINCSPEC="`$MAKE -f ../../f90modules/Makefile f90modspec`"
+ 	    F90_MODINCFLAG="`$MAKE -s -f ../../f90modules/Makefile f90modflag`"
+  	    F90MODINCSPEC="`$MAKE -s -f ../../f90modules/Makefile f90modspec`"
             if test -z "$USER_SET_F90INC" -a -z "$F90INC" ; then
 	        # This should use a test or try to get it from the f90module.
-	        F90INC=`$MAKE -f ../../f90modules/Makefile f90incflag`
+	        F90INC=`$MAKE -s -f ../../f90modules/Makefile f90incflag`
             fi
         fi
     fi

For some reason, make was printing "make[1]: entering directory..."
(and confusing the build). And this resulted in a bad config.status,
with sed errors (and commands like sed s,make[1] ...),  which produced
an empty mpe_fortdefs.h, which didn't result in defines for the
relevant MPI_* stuff.

I have attached a patch and a successful build log. I hope this is
useful to you to base your changes on. Please note that my fixes are
far from elegant, but I didn't have (or try spending) the time to make
them neat...

And, I have raised the severity of the bug to important since this is
part of the gfortran transition. (But if you thought it's just because
I want more brownie points for producing a patch for an important bug,
well I won't deny it! :-)

HTH.

Kumar
-- 
Kumar Appaiah,
458, Jamuna Hostel,
Indian Institute of Technology Madras,
Chennai - 600 036
[mpich_fix_3.diff (text/x-diff, attachment)]
[mpich_1.2.7-5.1_amd64.build.gz (application/octet-stream, attachment)]
[signature.asc (application/pgp-signature, inline)]

Severity set to `important' from `wishlist' Request was from Kumar Appaiah <akumar@ee.iitm.ac.in> to control@bugs.debian.org. (Thu, 31 Jan 2008 06:00:08 GMT) Full text and rfc822 format available.

Tags added: patch Request was from Kumar Appaiah <akumar@ee.iitm.ac.in> to control@bugs.debian.org. (Thu, 31 Jan 2008 06:00:09 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, hazelsct@debian.org (Adam C. Powell, IV):
Bug#195509; Package mpich. Full text and rfc822 format available.

Acknowledgement sent to Colin Tuckley <colint@debian.org>:
Extra info received and forwarded to list. Copy sent to hazelsct@debian.org (Adam C. Powell, IV). Full text and rfc822 format available.

Message #127 received at 195509@bugs.debian.org (full text, mbox):

From: Colin Tuckley <colint@debian.org>
To: Kumar Appaiah <akumar@ee.iitm.ac.in>, 195509@bugs.debian.org
Subject: Re: Bug#195509: Proceeding on this bug.
Date: Thu, 31 Jan 2008 08:24:39 +0000
Kumar Appaiah wrote:

> Er, apologies for the previous post... it failed due to getarg, in all
> likelihood. I missed reading the logs properly.

ARM Ltd are sponsoring work by CodeSourcery (the gFortran compiler writers)
to fix the GETARG problem, but it will be a few weeks before we see anything
I think.

Colin

-- 
Colin Tuckley      |  +44(0)1903 236872  |  PGP/GnuPG Key Id
Debian Developer   |  +44(0)7799 143369  |     0x1B3045CE

There are 10 types of people in the world. Those that know binary, and those
that don't.




Information forwarded to debian-bugs-dist@lists.debian.org, hazelsct@debian.org (Adam C. Powell, IV):
Bug#195509; Package mpich. Full text and rfc822 format available.

Acknowledgement sent to Adam C Powell IV <hazelsct@debian.org>:
Extra info received and forwarded to list. Copy sent to hazelsct@debian.org (Adam C. Powell, IV). Full text and rfc822 format available.

Message #132 received at 195509@bugs.debian.org (full text, mbox):

From: Adam C Powell IV <hazelsct@debian.org>
To: Kumar Appaiah <akumar@ee.iitm.ac.in>, 195509@bugs.debian.org
Subject: Re: Bug#195509: Proceeding on this bug.
Date: Thu, 31 Jan 2008 07:40:20 -0500
On Thu, 2008-01-31 at 11:36 +0530, Kumar Appaiah wrote:
> # Bcc'ing control
> severity 195509 important
> tags 195509 + patch
> thanks
> 
> On Thu, Jan 31, 2008 at 09:25:30AM +0530, Kumar Appaiah wrote:
> > @@ -170,7 +170,10 @@
> >          libbase=`basename $libname .a`
> >  	# The -h name sets the name of the object; this is necessary to 
> >  	# ensure that the dynamic linker can find the proper shared library.
> > -        if $CLINKER -shared -Wl,-h,$libbase.$slsuffix -o ../shared/$libbase.$slsuffix *.o $OtherLibs ; then
> > +        export F77_GETARGDECL="intrinsic GETARG"
> > +	if $CLINKER -shared -Wl,-h,$libbase.$slsuffix -o ../shared/$libbase.$slsuffix *.o $OtherLibs ; then
> > +	    echo Successfully linked $libname
> > +	elif gfortran-4.3 -shared -Wl,-h,$libbase.$slsuffix -o ../shared/$libbase.$slsuffix *.o $OtherLibs ; then
> >  	    echo Successfully linked $libname
> >  	else
> >  	    echo "Linking $libname shared lib failed " 
> > 
> > This is certainly not good, but seems to work. Maybe you can refine
> > it. This is also the reason why you see the getarg errors interspersed
> > in the build logs.
> > 
> > Now, the failure is this:
> 
> [snip]
> 
> > I have no idea on how to handle this. My observation is that the lines
> > in question are related to some "f2c" and "c2f". For example, the
> > lines in question in mpi.h are:
> 
> [snip more]
> 
> Further diagnosis showed that these are the error causing lines, along
> with the fixes:
> 
> diff -u mpich-1.2.7/src/fortran/configure mpich-1.2.7/src/fortran/configure
> --- mpich-1.2.7/src/fortran/configure
> +++ mpich-1.2.7/src/fortran/configure
> @@ -15820,11 +15820,11 @@
>  	    # turn off f90
>  	    F90=""
>  	else
> - 	    F90_MODINCFLAG="`$MAKE -f ../../f90modules/Makefile f90modflag`"
> -  	    F90MODINCSPEC="`$MAKE -f ../../f90modules/Makefile f90modspec`"
> + 	    F90_MODINCFLAG="`$MAKE -s -f ../../f90modules/Makefile f90modflag`"
> +  	    F90MODINCSPEC="`$MAKE -s -f ../../f90modules/Makefile f90modspec`"
>              if test -z "$USER_SET_F90INC" -a -z "$F90INC" ; then
>  	        # This should use a test or try to get it from the f90module.
> -	        F90INC=`$MAKE -f ../../f90modules/Makefile f90incflag`
> +	        F90INC=`$MAKE -s -f ../../f90modules/Makefile f90incflag`
>              fi
>          fi
>      fi
> 
> For some reason, make was printing "make[1]: entering directory..."
> (and confusing the build). And this resulted in a bad config.status,
> with sed errors (and commands like sed s,make[1] ...),  which produced
> an empty mpe_fortdefs.h, which didn't result in defines for the
> relevant MPI_* stuff.
> 
> I have attached a patch and a successful build log. I hope this is
> useful to you to base your changes on. Please note that my fixes are
> far from elegant, but I didn't have (or try spending) the time to make
> them neat...

Terrific!  Thanks for the hard work!  I'll neaten them up myself, that's
the easy part.

> And, I have raised the severity of the bug to important since this is
> part of the gfortran transition. (But if you thought it's just because
> I want more brownie points for producing a patch for an important bug,
> well I won't deny it! :-)

Actually, given how many years this bug has been open, and that it's
holding up a major transition, and several people have bugged me about
it, I'd say "important" is a fair characterization. :-)

-Adam
-- 
GPG fingerprint: D54D 1AEE B11C CE9B A02B  C5DD 526F 01E8 564E E4B6

Engineering consulting with open source tools
http://www.opennovation.com/





Information forwarded to debian-bugs-dist@lists.debian.org, hazelsct@debian.org (Adam C. Powell, IV):
Bug#195509; Package mpich. Full text and rfc822 format available.

Acknowledgement sent to Adam C Powell IV <hazelsct@debian.org>:
Extra info received and forwarded to list. Copy sent to hazelsct@debian.org (Adam C. Powell, IV). Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, hazelsct@debian.org (Adam C. Powell, IV):
Bug#195509; Package mpich. Full text and rfc822 format available.

Acknowledgement sent to Adam C Powell IV <hazelsct@debian.org>:
Extra info received and forwarded to list. Copy sent to hazelsct@debian.org (Adam C. Powell, IV). Full text and rfc822 format available.

Message #142 received at 195509@bugs.debian.org (full text, mbox):

From: Adam C Powell IV <hazelsct@debian.org>
To: 195509@bugs.debian.org
Cc: Kumar Appaiah <akumar@ee.iitm.ac.in>
Subject: Re: Bug#195509: Proceeding on this bug.
Date: Fri, 01 Feb 2008 16:25:47 -0500
On Thu, 2008-01-31 at 07:40 -0500, Adam C Powell IV wrote:
> On Thu, 2008-01-31 at 11:36 +0530, Kumar Appaiah wrote:
> > Further diagnosis showed that these are the error causing lines, along
> > with the fixes:
> > 
> > diff -u mpich-1.2.7/src/fortran/configure mpich-1.2.7/src/fortran/configure
> > --- mpich-1.2.7/src/fortran/configure
> > +++ mpich-1.2.7/src/fortran/configure
> > @@ -15820,11 +15820,11 @@
> >  	    # turn off f90
> >  	    F90=""
> >  	else
> > - 	    F90_MODINCFLAG="`$MAKE -f ../../f90modules/Makefile f90modflag`"
> > -  	    F90MODINCSPEC="`$MAKE -f ../../f90modules/Makefile f90modspec`"
> > + 	    F90_MODINCFLAG="`$MAKE -s -f ../../f90modules/Makefile f90modflag`"
> > +  	    F90MODINCSPEC="`$MAKE -s -f ../../f90modules/Makefile f90modspec`"
> >              if test -z "$USER_SET_F90INC" -a -z "$F90INC" ; then
> >  	        # This should use a test or try to get it from the f90module.
> > -	        F90INC=`$MAKE -f ../../f90modules/Makefile f90incflag`
> > +	        F90INC=`$MAKE -s -f ../../f90modules/Makefile f90incflag`
> >              fi
> >          fi
> >      fi
> > 
> > For some reason, make was printing "make[1]: entering directory..."
> > (and confusing the build). And this resulted in a bad config.status,
> > with sed errors (and commands like sed s,make[1] ...),  which produced
> > an empty mpe_fortdefs.h, which didn't result in defines for the
> > relevant MPI_* stuff.

I'm not getting something here.  In my build, and I see in yours as
well, there's this:

make --no-print-directory mpi-addons
Making a shared library of libmpich.a
farg.o: In function `mpir_iargc_':
farg.f:(.text+0x9): undefined reference to `_gfortran_iargc'
farg.o: In function `mpir_getarg_':
farg.f:(.text+0x39): undefined reference to `_gfortran_getarg_i4'
collect2: ld returned 1 exit status
Successfully linked libmpich.a
Making a shared library of libpmpich.a
farg.o: In function `mpir_iargc_':
farg.f:(.text+0x9): undefined reference to `_gfortran_iargc'
farg.o: In function `mpir_getarg_':
farg.f:(.text+0x39): undefined reference to `_gfortran_getarg_i4'
collect2: ld returned 1 exit status
Successfully linked libpmpich.a
Making a shared library of libfmpich.a
farg.o: In function `mpir_iargc_':
farg.f:(.text+0x9): undefined reference to `_gfortran_iargc'
farg.o: In function `mpir_getarg_':
farg.f:(.text+0x39): undefined reference to `_gfortran_getarg_i4'
collect2: ld returned 1 exit status
Successfully linked libfmpich.a
Making a shared library of libpmpich++.a
Successfully linked libpmpich++.a
Testing that MPI applications can be linked with shared libs...

Funny thing is, the libraries are there, and mpicc seems to be able to
use them.  So it seems to work, but I'm not sure I understand how or
why...  Any ideas?

I've neatened up the patches, and am putting everything at
http://lyre.mit.edu/~powell/mpich/ with a bunch of new mpif90 support
stuff.  If you're sure it's right, I'll upload it.  But it will have to
get through the new queue because of the ldbl->gf name change.

I don't have anything real to test it now, because I've migrated all of
my code to OpenMPI.  That's why I filed the RFA bug #447678...

Thanks again, this is a real milestone for the mpich package!

[BTW, are you on debian-beowulf and/or debian-science?  If so, I won't
CC you in my announcement to those lists of the mpich transition.]

-Adam
-- 
GPG fingerprint: D54D 1AEE B11C CE9B A02B  C5DD 526F 01E8 564E E4B6

Engineering consulting with open source tools
http://www.opennovation.com/





Information forwarded to debian-bugs-dist@lists.debian.org, hazelsct@debian.org (Adam C. Powell, IV):
Bug#195509; Package mpich. Full text and rfc822 format available.

Acknowledgement sent to "Kumar Appaiah" <akumar@ee.iitm.ac.in>:
Extra info received and forwarded to list. Copy sent to hazelsct@debian.org (Adam C. Powell, IV). Full text and rfc822 format available.

Message #147 received at 195509@bugs.debian.org (full text, mbox):

From: "Kumar Appaiah" <akumar@ee.iitm.ac.in>
To: "Adam C Powell IV" <hazelsct@debian.org>
Cc: 195509@bugs.debian.org
Subject: Re: Bug#195509: Proceeding on this bug.
Date: Sat, 2 Feb 2008 09:20:19 +0530
On 02/02/2008, Adam C Powell IV wrote:
> On Thu, 2008-01-31 at 07:40 -0500, Adam C Powell IV wrote:
> > On Thu, 2008-01-31 at 11:36 +0530, Kumar Appaiah wrote:
> > > Further diagnosis showed that these are the error causing lines, along
> > > with the fixes:
> > >
> > > diff -u mpich-1.2.7/src/fortran/configure mpich-1.2.7/src/fortran/configure
> > > --- mpich-1.2.7/src/fortran/configure
> > > +++ mpich-1.2.7/src/fortran/configure
> > > @@ -15820,11 +15820,11 @@
> > >         # turn off f90
> > >         F90=""
> > >     else
> > > -       F90_MODINCFLAG="`$MAKE -f ../../f90modules/Makefile f90modflag`"
> > > -       F90MODINCSPEC="`$MAKE -f ../../f90modules/Makefile f90modspec`"
> > > +       F90_MODINCFLAG="`$MAKE -s -f ../../f90modules/Makefile f90modflag`"
> > > +       F90MODINCSPEC="`$MAKE -s -f ../../f90modules/Makefile f90modspec`"
> > >              if test -z "$USER_SET_F90INC" -a -z "$F90INC" ; then
> > >             # This should use a test or try to get it from the f90module.
> > > -           F90INC=`$MAKE -f ../../f90modules/Makefile f90incflag`
> > > +           F90INC=`$MAKE -s -f ../../f90modules/Makefile f90incflag`
> > >              fi
> > >          fi
> > >      fi
> > >
> > > For some reason, make was printing "make[1]: entering directory..."
> > > (and confusing the build). And this resulted in a bad config.status,
> > > with sed errors (and commands like sed s,make[1] ...),  which produced
> > > an empty mpe_fortdefs.h, which didn't result in defines for the
> > > relevant MPI_* stuff.
>
> I'm not getting something here.  In my build, and I see in yours as
> well, there's this:
>
> make --no-print-directory mpi-addons
> Making a shared library of libmpich.a
> farg.o: In function `mpir_iargc_':
> farg.f:(.text+0x9): undefined reference to `_gfortran_iargc'
> farg.o: In function `mpir_getarg_':
> farg.f:(.text+0x39): undefined reference to `_gfortran_getarg_i4'
> collect2: ld returned 1 exit status
> Successfully linked libmpich.a
> Making a shared library of libpmpich.a
> farg.o: In function `mpir_iargc_':
> farg.f:(.text+0x9): undefined reference to `_gfortran_iargc'
> farg.o: In function `mpir_getarg_':
> farg.f:(.text+0x39): undefined reference to `_gfortran_getarg_i4'
> collect2: ld returned 1 exit status
> Successfully linked libpmpich.a
> Making a shared library of libfmpich.a
> farg.o: In function `mpir_iargc_':
> farg.f:(.text+0x9): undefined reference to `_gfortran_iargc'
> farg.o: In function `mpir_getarg_':
> farg.f:(.text+0x39): undefined reference to `_gfortran_getarg_i4'
> collect2: ld returned 1 exit status
> Successfully linked libfmpich.a
> Making a shared library of libpmpich++.a
> Successfully linked libpmpich++.a
> Testing that MPI applications can be linked with shared libs...

This is due to the following patch I introduced:

@@ -170,7 +170,10 @@
         libbase=`basename $libname .a`
    # The -h name sets the name of the object; this is necessary to
    # ensure that the dynamic linker can find the proper shared library.
-        if $CLINKER -shared -Wl,-h,$libbase.$slsuffix -o
../shared/$libbase.$slsuffix *.o $OtherLibs ; then
+        export F77_GETARGDECL="intrinsic GETARG"
+   if $CLINKER -shared -Wl,-h,$libbase.$slsuffix -o
../shared/$libbase.$slsuffix *.o $OtherLibs ; then
+       echo Successfully linked $libname
+   elif gfortran -shared -Wl,-h,$libbase.$slsuffix -o
../shared/$libbase.$slsuffix *.o $OtherLibs ; then
        echo Successfully linked $libname
    else
        echo "Linking $libname shared lib failed "

Note that $CLINKER will fail to resolve the getarg calls. However, the
elif case retries with gfortran, and thus, ends up linking fine. The
ideal solution would be for you to use $CLINKER for those stuff which
don't need GETARG, and gfortran for linking the stuff which uses
GETARG.

> Funny thing is, the libraries are there, and mpicc seems to be able to
> use them.  So it seems to work, but I'm not sure I understand how or
> why...  Any ideas?

So, I'd suggest you list out the libraries which need getarg, and link
them using gfortran, and others using $CLINKER. Sounds OK?

> I've neatened up the patches, and am putting everything at
> http://lyre.mit.edu/~powell/mpich/ with a bunch of new mpif90 support
> stuff.  If you're sure it's right, I'll upload it.  But it will have to
> get through the new queue because of the ldbl->gf name change.

I guess things should be fine, though you might want others with
rdepends to check. To allay fears of breakage, experimental might be
OK?

> Thanks again, this is a real milestone for the mpich package!

I am glad to have been of help!

> [BTW, are you on debian-beowulf and/or debian-science?  If so, I won't
> CC you in my announcement to those lists of the mpich transition.]

No, I am not (yet). Please do CC me, though I'll be a mere observer.

Many thanks.

Kumar
-- 
Kumar Appaiah,
458, Jamuna Hostel,
Indian Institute of Technology Madras,
Chennai - 600036




Information forwarded to debian-bugs-dist@lists.debian.org, hazelsct@debian.org (Adam C. Powell, IV):
Bug#195509; Package mpich. Full text and rfc822 format available.

Acknowledgement sent to Adam C Powell IV <hazelsct@debian.org>:
Extra info received and forwarded to list. Copy sent to hazelsct@debian.org (Adam C. Powell, IV). Full text and rfc822 format available.

Message #152 received at 195509@bugs.debian.org (full text, mbox):

From: Adam C Powell IV <hazelsct@debian.org>
To: Kumar Appaiah <akumar@ee.iitm.ac.in>, 195509@bugs.debian.org
Subject: Re: Bug#195509: Proceeding on this bug.
Date: Mon, 04 Feb 2008 10:21:41 -0500
On Sat, 2008-02-02 at 09:20 +0530, Kumar Appaiah wrote:
> On 02/02/2008, Adam C Powell IV wrote:
> > On Thu, 2008-01-31 at 07:40 -0500, Adam C Powell IV wrote:
> > > On Thu, 2008-01-31 at 11:36 +0530, Kumar Appaiah wrote:
> > > > Further diagnosis showed that these are the error causing lines, along
> > > > with the fixes:
> > > >
> > > > diff -u mpich-1.2.7/src/fortran/configure mpich-1.2.7/src/fortran/configure
> > > > --- mpich-1.2.7/src/fortran/configure
> > > > +++ mpich-1.2.7/src/fortran/configure
> > > > @@ -15820,11 +15820,11 @@
> > > >         # turn off f90
> > > >         F90=""
> > > >     else
> > > > -       F90_MODINCFLAG="`$MAKE -f ../../f90modules/Makefile f90modflag`"
> > > > -       F90MODINCSPEC="`$MAKE -f ../../f90modules/Makefile f90modspec`"
> > > > +       F90_MODINCFLAG="`$MAKE -s -f ../../f90modules/Makefile f90modflag`"
> > > > +       F90MODINCSPEC="`$MAKE -s -f ../../f90modules/Makefile f90modspec`"
> > > >              if test -z "$USER_SET_F90INC" -a -z "$F90INC" ; then
> > > >             # This should use a test or try to get it from the f90module.
> > > > -           F90INC=`$MAKE -f ../../f90modules/Makefile f90incflag`
> > > > +           F90INC=`$MAKE -s -f ../../f90modules/Makefile f90incflag`
> > > >              fi
> > > >          fi
> > > >      fi
> > > >
> > > > For some reason, make was printing "make[1]: entering directory..."
> > > > (and confusing the build). And this resulted in a bad config.status,
> > > > with sed errors (and commands like sed s,make[1] ...),  which produced
> > > > an empty mpe_fortdefs.h, which didn't result in defines for the
> > > > relevant MPI_* stuff.
> >
> > I'm not getting something here.  In my build, and I see in yours as
> > well, there's this:
> >
> > make --no-print-directory mpi-addons
> > Making a shared library of libmpich.a
> > farg.o: In function `mpir_iargc_':
> > farg.f:(.text+0x9): undefined reference to `_gfortran_iargc'
> > farg.o: In function `mpir_getarg_':
> > farg.f:(.text+0x39): undefined reference to `_gfortran_getarg_i4'
> > collect2: ld returned 1 exit status
> > Successfully linked libmpich.a
> > Making a shared library of libpmpich.a
> > farg.o: In function `mpir_iargc_':
> > farg.f:(.text+0x9): undefined reference to `_gfortran_iargc'
> > farg.o: In function `mpir_getarg_':
> > farg.f:(.text+0x39): undefined reference to `_gfortran_getarg_i4'
> > collect2: ld returned 1 exit status
> > Successfully linked libpmpich.a
> > Making a shared library of libfmpich.a
> > farg.o: In function `mpir_iargc_':
> > farg.f:(.text+0x9): undefined reference to `_gfortran_iargc'
> > farg.o: In function `mpir_getarg_':
> > farg.f:(.text+0x39): undefined reference to `_gfortran_getarg_i4'
> > collect2: ld returned 1 exit status
> > Successfully linked libfmpich.a
> > Making a shared library of libpmpich++.a
> > Successfully linked libpmpich++.a
> > Testing that MPI applications can be linked with shared libs...
> 
> This is due to the following patch I introduced:
> 
> @@ -170,7 +170,10 @@
>          libbase=`basename $libname .a`
>     # The -h name sets the name of the object; this is necessary to
>     # ensure that the dynamic linker can find the proper shared library.
> -        if $CLINKER -shared -Wl,-h,$libbase.$slsuffix -o
> ../shared/$libbase.$slsuffix *.o $OtherLibs ; then
> +        export F77_GETARGDECL="intrinsic GETARG"
> +   if $CLINKER -shared -Wl,-h,$libbase.$slsuffix -o
> ../shared/$libbase.$slsuffix *.o $OtherLibs ; then
> +       echo Successfully linked $libname
> +   elif gfortran -shared -Wl,-h,$libbase.$slsuffix -o
> ../shared/$libbase.$slsuffix *.o $OtherLibs ; then
>         echo Successfully linked $libname
>     else
>         echo "Linking $libname shared lib failed "
> 
> Note that $CLINKER will fail to resolve the getarg calls. However, the
> elif case retries with gfortran, and thus, ends up linking fine. The
> ideal solution would be for you to use $CLINKER for those stuff which
> don't need GETARG, and gfortran for linking the stuff which uses
> GETARG.

Ah yes, forgot about that.  Thanks for the clarification.  I'll go ahead
and upload.  It would be nice if it didn't print the error messages...
Maybe for -7 I'll have it print a success message if gfortran works.

[snip]

> > I've neatened up the patches, and am putting everything at
> > http://lyre.mit.edu/~powell/mpich/ with a bunch of new mpif90 support
> > stuff.  If you're sure it's right, I'll upload it.  But it will have to
> > get through the new queue because of the ldbl->gf name change.
> 
> I guess things should be fine, though you might want others with
> rdepends to check. To allay fears of breakage, experimental might be
> OK?

Because mpicc and friends seem to work, I think I'll try unstable and if
it causes problems I'll deal with those later.

> > [BTW, are you on debian-beowulf and/or debian-science?  If so, I won't
> > CC you in my announcement to those lists of the mpich transition.]
> 
> No, I am not (yet). Please do CC me, though I'll be a mere observer.

Okay, will do.

Thanks again,
-Adam
-- 
GPG fingerprint: D54D 1AEE B11C CE9B A02B  C5DD 526F 01E8 564E E4B6

Engineering consulting with open source tools
http://www.opennovation.com/





Tags added: pending Request was from Anibal Monsalve Salazar <anibal@debian.org> to control@bugs.debian.org. (Mon, 04 Feb 2008 23:06:07 GMT) Full text and rfc822 format available.

Reply sent to hazelsct@debian.org (Adam C. Powell, IV):
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Egon Willighagen <egonw@sci.kun.nl>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #159 received at 195509-close@bugs.debian.org (full text, mbox):

From: hazelsct@debian.org (Adam C. Powell, IV)
To: 195509-close@bugs.debian.org
Subject: Bug#195509: fixed in mpich 1.2.7-6
Date: Sat, 09 Feb 2008 16:14:19 +0000
Source: mpich
Source-Version: 1.2.7-6

We believe that the bug you reported is fixed in the latest version of
mpich, which is due to be installed in the Debian FTP archive:

libmpich-mpd1.0-dev_1.2.7-6_amd64.deb
  to pool/main/m/mpich/libmpich-mpd1.0-dev_1.2.7-6_amd64.deb
libmpich-mpd1.0gf_1.2.7-6_amd64.deb
  to pool/main/m/mpich/libmpich-mpd1.0gf_1.2.7-6_amd64.deb
libmpich-shmem1.0-dev_1.2.7-6_amd64.deb
  to pool/main/m/mpich/libmpich-shmem1.0-dev_1.2.7-6_amd64.deb
libmpich-shmem1.0gf_1.2.7-6_amd64.deb
  to pool/main/m/mpich/libmpich-shmem1.0gf_1.2.7-6_amd64.deb
libmpich1.0-dev_1.2.7-6_amd64.deb
  to pool/main/m/mpich/libmpich1.0-dev_1.2.7-6_amd64.deb
libmpich1.0gf_1.2.7-6_amd64.deb
  to pool/main/m/mpich/libmpich1.0gf_1.2.7-6_amd64.deb
mpe-source_1.2.7-6_all.deb
  to pool/main/m/mpich/mpe-source_1.2.7-6_all.deb
mpi-doc_1.2.7-6_all.deb
  to pool/main/m/mpich/mpi-doc_1.2.7-6_all.deb
mpich-bin_1.2.7-6_amd64.deb
  to pool/main/m/mpich/mpich-bin_1.2.7-6_amd64.deb
mpich-mpd-bin_1.2.7-6_amd64.deb
  to pool/main/m/mpich/mpich-mpd-bin_1.2.7-6_amd64.deb
mpich-shmem-bin_1.2.7-6_amd64.deb
  to pool/main/m/mpich/mpich-shmem-bin_1.2.7-6_amd64.deb
mpich_1.2.7-6.diff.gz
  to pool/main/m/mpich/mpich_1.2.7-6.diff.gz
mpich_1.2.7-6.dsc
  to pool/main/m/mpich/mpich_1.2.7-6.dsc



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 195509@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Adam C. Powell, IV <hazelsct@debian.org> (supplier of updated mpich package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Fri, 01 Feb 2008 16:06:59 -0500
Source: mpich
Binary: mpich-bin mpich-mpd-bin mpich-shmem-bin libmpich1.0-dev libmpich-mpd1.0-dev libmpich-shmem1.0-dev libmpich1.0gf libmpich-mpd1.0gf libmpich-shmem1.0gf mpi-doc mpe-source
Architecture: source all amd64
Version: 1.2.7-6
Distribution: unstable
Urgency: low
Maintainer: Adam C. Powell, IV <hazelsct@debian.org>
Changed-By: Adam C. Powell, IV <hazelsct@debian.org>
Description: 
 libmpich-mpd1.0-dev - mpich static libraries and development files
 libmpich-mpd1.0gf - mpich-mpd runtime shared library
 libmpich-shmem1.0-dev - mpich static libraries and development files
 libmpich-shmem1.0gf - mpich-shmem runtime shared library
 libmpich1.0-dev - mpich static libraries and development files
 libmpich1.0gf - mpich runtime shared library
 mpe-source - Source for MPE, for other package to build-depend
 mpi-doc    - Documentation for the MPICH MPI implementation and user's guides
 mpich-bin  - MPI parallel computing system implementation
 mpich-mpd-bin - MPI parallel computing system implementation, MPD version
 mpich-shmem-bin - MPI parallel computing system implementation, SHMEM version
Closes: 195509
Changes: 
 mpich (1.2.7-6) unstable; urgency=low
 .
   * Working gfortran support (thanks to Kumar Appaiah <akumar@ee.iitm.ac.in>).
   * This release also includes mpif90 (closes: #195509).
   * Changed shlib package names to gf reflecting the interface change due to
     the g77-gfortran transition.
Files: 
 5d63e44a7b504e922efd2170a075d569 845 devel extra mpich_1.2.7-6.dsc
 a6dfec19eedd518005836580fedd4513 234070 devel extra mpich_1.2.7-6.diff.gz
 d3d2135a8150831c1e62dd07d66fe502 3560466 doc optional mpi-doc_1.2.7-6_all.deb
 aebd4224d5774546b5b2cb9ebe7e5a9f 7339984 devel extra mpe-source_1.2.7-6_all.deb
 b6ba90b6b23321e23c066c808bd91524 223348 devel extra mpich-bin_1.2.7-6_amd64.deb
 f8677939027d6b007360c61fca152685 285278 devel extra mpich-mpd-bin_1.2.7-6_amd64.deb
 75ca5cd7e9181a544f3e1017a7d806f4 151116 devel extra mpich-shmem-bin_1.2.7-6_amd64.deb
 10f156b927ea046538c6a3f906d9805e 1542196 libdevel extra libmpich1.0-dev_1.2.7-6_amd64.deb
 2339eac32f8298f619fe6d16c7647c24 1544774 libdevel extra libmpich-mpd1.0-dev_1.2.7-6_amd64.deb
 c67b1dd54004543077f2ac20465def17 1485626 libdevel extra libmpich-shmem1.0-dev_1.2.7-6_amd64.deb
 c3b1bde72cd6fb0fca05232344ba20e7 15018 libs extra libmpich1.0gf_1.2.7-6_amd64.deb
 1ad4a5d429764affe251d921c294302e 15036 libs extra libmpich-mpd1.0gf_1.2.7-6_amd64.deb
 98d4a64db34ded3bb5006c59fddc8572 15038 libs extra libmpich-shmem1.0gf_1.2.7-6_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.6 (GNU/Linux)

iD8DBQFHo44JUm8B6FZO5LYRAiC0AJwL7vSdgZ5T7UgmWMSZ2jHMQq4fcwCfQYso
dqK4IzDhSyOIN2lqaaUIbGI=
=+JVB
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sun, 11 May 2008 07:43:56 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 23 07:24:56 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.